# coding: latin-1

import sys, urllib2

def urlcheck(u):
	""" Une manire simple (simpliste?) de vrifier la validit d'une URL """
	# Remarque: cette fonction ne se limitant pas  une simple expression,
	# il est impossible (en python) de la mettre sous forme de lambda-fonction...
	try:
		urllib2.urlopen(u)
		return True
	except: return False

def checkurls(urls):
	"""En utilisant filter:
	"""
	return filter(urlcheck, urls)
	
def checkurls2(urls):
	"""En utilisant une "list comprehension":
	"""
	return [u for u in urls if urlcheck(u)]
	
def checkurls3(urls):
	"""En utilisant une "generator expression": 
	-> Notez que dans ce cas, les rsultats s'affichent au fur et 
	 mesure, sans attendre que toutes les urls soient vrifies!
	"""
	return (u for u in urls if urlcheck(u))
	
if __name__ == '__main__':
	
	urls = [
		'http://www.he-arc.ch',
		'http://www.google.com',
		'www.he-arc',
		'http://www.cff.ch',
		'http://inexistant.ch',
	]

	for fonct in [checkurls,checkurls2,checkurls3]:
		print fonct.__doc__
		for u in fonct(urls):
			print u
		print