# coding: latin-1

import sys

def debug(f):
	""" Un dcorateur qui affiche les entres et sorties de la fonction dcore """
	def inner(*args, **kwargs):
		# Affiche les entres
		print "*** Calling", f.__name__
		print "***     args:", args
		print "***     kwargs:", kwargs
		# Appelle la fonction dcore
		try:
			result = f(*args, **kwargs)
		except Exception, e:
			# En cas d'exception, on l'affiche...
			print "*** An error occurred in", f.__name__
			print "***     ", e
			# ... mais on la transmet plus loin!
			raise
		else:
			# Affiche les sorties
			print "*** Exiting %s normally" % f.__name__
			print "***     result:", result
	# Pour faire un dcorateur "bien lev"
	inner.__doc__ = f.__doc__
	inner.__name__ = f.__name__
	inner.__dict__.update(f.__dict__)
	return inner

if __name__ == "__main__":
	@debug
	def test(x,y,z=0):
		print "x,y,z = %d, %d, %d" % (x,y,z)
		return x+y/z
		
	test(1,2,3)
	try:
		test(1,2)
	except: 
		print "Exception catched!"
	test(1, z=3, y=2)
	try:
		test()
	except: 
		print "Exception catched!"
