# coding: latin-1

def count_calls(f):
	""" Dcorateur qui compte les appels fait  la fonction dcore et
	stocke cette valeur dans l'attribut nbcalls de la fonction.
	"""
	def inner(*args, **kwargs):
		inner.nbcalls += 1
		return  f(*args, **kwargs)
	inner.nbcalls = 0
	# Pour faire un dcorateur "bien lev"
	inner.__doc__ = f.__doc__
	inner.__name__ = f.__name__
	inner.__dict__.update(f.__dict__)
	return inner


if __name__ == "__main__":
	@count_calls
	def test():
		print "test called"
		
	print test.nbcalls
	test()
	test()
	print test.nbcalls
	test()
	print test.nbcalls