# coding: latin-1

def cast_args(*types):
	""" Ce dcorateur, lors de l'appel de la fonction dcore, force les types
	des arguments  la signature donne dans *types
	"""
	def deco(f):
		# Lors de l'appel de la fonction...
		def inner(*args):
			# ... on force la signature
			newargs = [t(a) for t,a in zip(types,args)]
			# ... et on passe tout a  la fonction!
			return f(*newargs)
		# Pour faire un dcorateur "bien lev"
		inner.__doc__ = f.__doc__
		inner.__name__ = f.__name__
		inner.__dict__.update(f.__dict__)
		return inner
	return deco
	
	
if __name__ == "__main__":
	@cast_args(str,int)
	def f(s,i):
		print "String: "+s
		print i+1
		
	f('12',2)
	f(12,'2')